#pragma once
#include <afxole.h>

class ITreeDropOwner
{
public:
	ITreeDropOwner(){};
	virtual ~ITreeDropOwner(){}

	virtual CWnd* GetCWnd(){return NULL; }
	virtual DROPEFFECT OnDragEnter(CWnd* pWnd , COleDataObject* pDataObject,
		DWORD dwKeyState, CPoint point) = 0;

	virtual DROPEFFECT OnDragOver(CWnd* pWnd , COleDataObject* pDataObject,
		DWORD dwKeyState, CPoint point) = 0;

	virtual DROPEFFECT OnDragScroll(CWnd* pWnd, DWORD dwKeyState, CPoint point) {return DROPEFFECT_NONE;}

	virtual void OnDragLeave() = 0;

	virtual BOOL OnDrop(CWnd* pWnd, COleDataObject* pDataObject,
		DROPEFFECT dropEffect, CPoint point) = 0;

	virtual SCODE GiveFeedback(DROPEFFECT dropEffect ) = 0;
};


class CTreeTDropTarget : public COleDropTarget
{
public:
	CTreeTDropTarget(ITreeDropOwner *pOwner) : m_pOwner(pOwner) 
	{
		//Register(pOwner->GetCWnd());
	}

	virtual ~CTreeTDropTarget()
	{
        //fix this(1506 -- Call to virtual function 'Symbol' within a constructor or destructor)
        //  move Revoke to MainFrame::OnFinalMessage(the only caller)

		//Revoke();
        m_pOwner = NULL;
	}
	DROPEFFECT OnDragEnter(CWnd* pWnd , COleDataObject* pDataObject,
		DWORD dwKeyState, CPoint point)
	{
		return m_pOwner->OnDragEnter(pWnd, pDataObject, dwKeyState, point);
	}

	DROPEFFECT OnDragOver(CWnd* pWnd , COleDataObject* pDataObject,
		DWORD dwKeyState, CPoint point)
	{
		return m_pOwner->OnDragOver(pWnd, pDataObject, dwKeyState, point);
	}

	DROPEFFECT OnDragScroll(CWnd* pWnd, DWORD dwKeyState, CPoint point)
	{
		return m_pOwner->OnDragScroll(pWnd, dwKeyState, point);
	}
	void OnDragLeave(CWnd*)
	{
		m_pOwner->OnDragLeave();
	}

	BOOL OnDrop(CWnd* pWnd, COleDataObject* pDataObject,
		DROPEFFECT dropEffect, CPoint point)
	{
		return m_pOwner->OnDrop(pWnd, pDataObject, dropEffect, point);
	}

private:
	ITreeDropOwner* m_pOwner;
};

class CPWTDropSource : public COleDropSource
{
public:
	CPWTDropSource(ITreeDropOwner *pOwner) : m_pOwner(pOwner) {}
	virtual SCODE GiveFeedback(DROPEFFECT dropEffect )
	{
		return m_pOwner->GiveFeedback(dropEffect);
	}
private:
	ITreeDropOwner* m_pOwner;
};
